<template>
  <div class="setting-direction-table">
    <ob-table
        :columns="columns"
        :items="personal_direction.docSettings.docSettings"
        :is-groups-opened="false"
        class="setting-direction-table__table"
    >
      <template v-slot:required_field="{ data }">
        <ob-checkbox
            v-model="data.item.required"
            property="required"
            @change="saveSettingByCustomer({
              ...data.item,
              locationStartUuid: personal_direction.locationStartUuid,
              locationEndUuid: personal_direction.locationEndUuid
            })"
        />
      </template>
      <template v-slot:count_field="{ data }">
        <ObInput
            v-model="data.item.count"
            class="setting-direction-table__input"
            type="money:0"
            :isConvertMoney="false"
            @blur="saveSettingByCustomer({
              ...data.item,
              locationStartUuid: personal_direction.locationStartUuid,
              locationEndUuid: personal_direction.locationEndUuid
            })"
            placeholder="0"
        />
      </template>
      <template v-slot:comment_field="{ data }">
        <ObInput
            v-model="data.item.comment"
            class="setting-direction-table__input"
            type="text"
            @blur="saveSettingByCustomer({
              ...data.item,
              locationStartUuid: personal_direction.locationStartUuid,
              locationEndUuid: personal_direction.locationEndUuid
            })"
            placeholder="0"
        />
      </template>
    </ob-table>
  </div>
</template>

<script>
  import ObTable from "common-components/src/obComponents/obTable";
  import ObCheckbox from "common-components/src/obComponents/obCheckbox";
  import ObInput from "common-components/src/obComponents/obInput";
  import {mapGetters, mapActions} from "vuex";
  export default {
    name: "DataTable",
    components: {
      ObTable,
      ObCheckbox,
      ObInput
    },
    data() {
      return {
        columns: [
          {
            title: 'Обязателен',
            key: 'required',
            isEditColumn: true,
            exactWidth: '10%',
            valueType: 'BOOLEAN',
            slotName: 'required_field'
          },
          {
            title: 'Документ',
            key: 'name',
            isEditColumn: false,
            exactWidth: '40%'
          },

          {
            title: 'Кол-во',
            key: 'count',
            slotName: 'count_field'
          },
          {
            title: 'Комментарий',
            key: 'comment',
            slotName: 'comment_field'
          }
        ]
      }
    },
    computed: {
      ...mapGetters({
        personal_direction: 'clicarSettings/personal_direction'
      })
    },
    methods: {
      ...mapActions({
        saveSettingByCustomer: 'clicarSettings/saveSettingByCustomer'
      })
    }
  }
</script>

<style scoped lang="scss">
  .setting-direction-table {
    padding: 0 20px;
  }
</style>

<style lang="scss">
  .setting-direction-table__table {
    .ob-input-wrap.--theme-default {
      border: 1px solid $color-grey-border !important;
      box-shadow: inset 0px 3px 6px rgba(25, 30, 50, 0.1) !important;
      border-radius: 3px !important;
      height: 27px;

      input {
        font-size: 12px;
        &::placeholder {
          font-size: 12px;
          color: $color-text-base;
        }
      }
    }
  }
</style>